> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://docs.0x.org/llms.txt.
> For full documentation content, see https://docs.0x.org/llms-full.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docs.0x.org/_mcp/server.

# listSources

GET https://api.0x.org/cross-chain/sources

List available swap and bridge sources for a cross chain swap

Reference: https://docs.0x.org/api-reference/0-x-api/cross-chain/cross-chain-list-sources

## OpenAPI Specification

```yaml
openapi: 3.1.0
info:
  title: 0x API
  version: 1.0.0
paths:
  /cross-chain/sources:
    get:
      operationId: cross-chain-list-sources
      summary: listSources
      description: List available swap and bridge sources for a cross chain swap
      tags:
        - subpackage_crossChain
      parameters:
        - name: 0x-api-key
          in: header
          description: Visit dashboard.0x.org to get your API Key
          required: true
          schema:
            type: string
      responses:
        '200':
          description: Successful response
          content:
            application/json:
              schema:
                $ref: >-
                  #/components/schemas/Cross-Chain_crossChain::listSources_Response_200
        '400':
          description: 400 error response
          content:
            application/json:
              schema:
                $ref: >-
                  #/components/schemas/CrossChain::listSourcesRequestBadRequestError
        '500':
          description: 500 error response
          content:
            application/json:
              schema:
                $ref: >-
                  #/components/schemas/CrossChain::listSourcesRequestInternalServerError
servers:
  - url: https://api.0x.org
components:
  schemas:
    CrossChainSourcesGetResponsesContentApplicationJsonSchemaBridgesItemsChainPairsItems:
      type: object
      properties:
        originChainId:
          type: number
          format: double
          description: The numeric chain ID of the origin chain
        destinationChainId:
          type: number
          format: double
          description: The numeric chain ID of the destination chain
      required:
        - originChainId
        - destinationChainId
      title: >-
        CrossChainSourcesGetResponsesContentApplicationJsonSchemaBridgesItemsChainPairsItems
    CrossChainSourcesGetResponsesContentApplicationJsonSchemaBridgesItems:
      type: object
      properties:
        name:
          type: string
          description: The name of the bridge provider
        chainPairs:
          type: array
          items:
            $ref: >-
              #/components/schemas/CrossChainSourcesGetResponsesContentApplicationJsonSchemaBridgesItemsChainPairsItems
          description: Origin-destination chain pairs supported by the bridge provider
      required:
        - name
        - chainPairs
      title: CrossChainSourcesGetResponsesContentApplicationJsonSchemaBridgesItems
    CrossChainSourcesGetResponsesContentApplicationJsonSchemaSwapSourcesItems:
      type: object
      properties:
        name:
          type: string
          description: The name of the liquidity sources aggregated by 0x
        chainIds:
          type: array
          items:
            type: number
            format: double
          description: >-
            The numeric chain IDs of the chains supported by the liquidity
            source
      required:
        - name
        - chainIds
      title: >-
        CrossChainSourcesGetResponsesContentApplicationJsonSchemaSwapSourcesItems
    Cross-Chain_crossChain::listSources_Response_200:
      type: object
      properties:
        bridges:
          type: array
          items:
            $ref: >-
              #/components/schemas/CrossChainSourcesGetResponsesContentApplicationJsonSchemaBridgesItems
          description: The array of bridge providers and their supported chain pairs
        swapSources:
          type: array
          items:
            $ref: >-
              #/components/schemas/CrossChainSourcesGetResponsesContentApplicationJsonSchemaSwapSourcesItems
          description: The array of liquidity sources and their supported chains
        zid:
          type: string
          description: The unique ZeroEx identifier of the request
      required:
        - bridges
        - swapSources
        - zid
      title: Cross-Chain_crossChain::listSources_Response_200
    InputInvalidName:
      type: string
      enum:
        - INPUT_INVALID
      title: InputInvalidName
    InputInvalidDataDetailsItems:
      type: object
      properties:
        field:
          type: string
          description: The input field name
        reason:
          type: string
          description: The validation failure reason
      required:
        - field
        - reason
      title: InputInvalidDataDetailsItems
    InputInvalidData:
      type: object
      properties:
        zid:
          type: string
          description: The unique ZeroEx identifier of the request
        details:
          type: array
          items:
            $ref: '#/components/schemas/InputInvalidDataDetailsItems'
          description: The list of invalid inputs
      required:
        - zid
        - details
      title: InputInvalidData
    INPUT_INVALID:
      type: object
      properties:
        name:
          $ref: '#/components/schemas/InputInvalidName'
        message:
          type: string
        data:
          $ref: '#/components/schemas/InputInvalidData'
      required:
        - name
        - message
        - data
      title: INPUT_INVALID
    CrossChain::listSourcesRequestBadRequestError:
      oneOf:
        - $ref: '#/components/schemas/INPUT_INVALID'
      title: CrossChain::listSourcesRequestBadRequestError
    InternalServerErrorName:
      type: string
      enum:
        - INTERNAL_SERVER_ERROR
      title: InternalServerErrorName
    InternalServerErrorData:
      type: object
      properties:
        zid:
          type: string
          description: The unique ZeroEx identifier of the request
      required:
        - zid
      title: InternalServerErrorData
    INTERNAL_SERVER_ERROR:
      type: object
      properties:
        name:
          $ref: '#/components/schemas/InternalServerErrorName'
        message:
          type: string
        data:
          $ref: '#/components/schemas/InternalServerErrorData'
      required:
        - name
        - message
        - data
      title: INTERNAL_SERVER_ERROR
    UncategorizedName:
      type: string
      enum:
        - UNCATEGORIZED
      title: UncategorizedName
    UncategorizedData:
      type: object
      properties:
        zid:
          type: string
          description: The unique ZeroEx identifier of the request
      required:
        - zid
      title: UncategorizedData
    UNCATEGORIZED:
      type: object
      properties:
        name:
          $ref: '#/components/schemas/UncategorizedName'
        message:
          type: string
        data:
          $ref: '#/components/schemas/UncategorizedData'
      required:
        - name
        - message
        - data
      title: UNCATEGORIZED
    CrossChain::listSourcesRequestInternalServerError:
      oneOf:
        - $ref: '#/components/schemas/INTERNAL_SERVER_ERROR'
        - $ref: '#/components/schemas/UNCATEGORIZED'
      title: CrossChain::listSourcesRequestInternalServerError

```

## SDK Code Examples

```python
import requests

url = "https://api.0x.org/cross-chain/sources"

payload = {}
headers = {
    "0x-api-key": "0x-api-key",
    "Content-Type": "application/json"
}

response = requests.get(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://api.0x.org/cross-chain/sources';
const options = {
  method: 'GET',
  headers: {'0x-api-key': '0x-api-key', 'Content-Type': 'application/json'},
  body: '{}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.0x.org/cross-chain/sources"

	payload := strings.NewReader("{}")

	req, _ := http.NewRequest("GET", url, payload)

	req.Header.Add("0x-api-key", "0x-api-key")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://api.0x.org/cross-chain/sources")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Get.new(url)
request["0x-api-key"] = '0x-api-key'
request["Content-Type"] = 'application/json'
request.body = "{}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.get("https://api.0x.org/cross-chain/sources")
  .header("0x-api-key", "0x-api-key")
  .header("Content-Type", "application/json")
  .body("{}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('GET', 'https://api.0x.org/cross-chain/sources', [
  'body' => '{}',
  'headers' => [
    '0x-api-key' => '0x-api-key',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://api.0x.org/cross-chain/sources");
var request = new RestRequest(Method.GET);
request.AddHeader("0x-api-key", "0x-api-key");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = [
  "0x-api-key": "0x-api-key",
  "Content-Type": "application/json"
]
let parameters = [] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api.0x.org/cross-chain/sources")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "GET"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```